<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Manager extends Controller {

    function __construct() {
            parent::Controller();
            $module_name = "apps";
            $this->load->helper('directory');
    }

    //---------------------------------------------------------------

    //<editor-fold desc="FUNCTION DESCRIPTION: SHOW THE APPS LIST PAGE">
    /*
     * Function: index
     * Description: Shows the apps listing
     * ##############################################################
     * Written: 01/04/2011
     * Author: Deep Arora
     * --------------------------------------------------------------
     * Update Log:
     * --------------------------------------------------------------
     * ##############################################################
     * @access public
     * @return void
     */
    //</editor-fold>
    function index()
    {
        //<editor-fold desc="CHECK USER PERMISSION">
        //smp_check_permission($this->config->item('perm_view'));
        //</editor-fold>

        //<editor-fold desc="SET PAGE META">
        smp_set_page_meta('apps', 'manager', '');
        //</editor-fold>
        //
        //<editor-fold desc="FETCHING DATA">
        $module_dirs = directory_map(APPPATH. '/modules/', TRUE);


        $result_set = array();

        for ($i = 0; $i < sizeof($module_dirs); $i++) {
            $module_info_class = APPPATH . "modules/" . $module_dirs[$i] . "/module_" . $module_dirs[$i] . ".php";
            $module_class_name = "Module_" . $module_dirs[$i];

            if(file_exists($module_info_class)){
                include $module_info_class;
                $objModule = new $module_class_name();
                $app_status = smp_lookup('flg_enable', $this->config->item('tbl_modules'), 'LOWER(title) = \'' . strtolower($objModule->get_app_name()) . '\'');
                $app_description = smp_lookup('description', $this->config->item('tbl_modules'), 'LOWER(title) = \'' . strtolower($objModule->get_app_name()) . '\'');
                $current_ver = smp_lookup('version', $this->config->item('tbl_modules'), 'LOWER(title) = \'' . strtolower($objModule->get_app_name()) . '\'');

                if (!$app_status){
                    $app_status = smp_lookup('flg_enable', $this->config->item('tbl_submodules'), 'LOWER(title) = \'' . strtolower($objModule->get_app_name()) . '\'');
                    $app_description = smp_lookup('description', $this->config->item('tbl_submodules'), 'LOWER(title) = \'' . strtolower($objModule->get_app_name()) . '\'');
                    $current_ver = smp_lookup('version', $this->config->item('tbl_submodules'), 'LOWER(title) = \'' . strtolower($objModule->get_app_name()) . '\'');
                }

                if (!$app_status){
                    $app_status = smp_lookup('flg_enable', $this->config->item('tbl_hooks'), 'LOWER(action_name) = \'' . strtolower($objModule->get_app_name()) . '\'');
                    $app_description = smp_lookup('action_description', $this->config->item('tbl_hooks'), 'LOWER(action_name) = \'' . strtolower($objModule->get_app_name()) . '\'');
                    $current_ver = smp_lookup('version', $this->config->item('tbl_hooks'), 'LOWER(action_name) = \'' . strtolower($objModule->get_app_name()) . '\'');
                }


                if (!$app_status){
                    $app_status = "D";
                }
                if (!$app_description){
                    $app_description = $objModule->get_app_description();
                }


                switch($app_status) {
                    case "Y":
                        $app_status = "Install";
                        $app_status .= PIPE;
                        $app_status .= "Activate";
                        $app_status .= PIPE;
                        if ($current_ver < $objModule->get_version()){
                            $app_status .= "<a href='". site_url('apps/manager/execute/upgrade/' . $objModule->get_app_name()) ."' title='Upgrade to version " . $objModule->get_version() . "'>Upgrade</a>";
                        }
                        else{
                            $app_status .= "Upgrade";
                        }
                        $app_status .= PIPE;
                        $app_status .= "<a href='". site_url('apps/manager/execute/disable/' . $objModule->get_app_name()) ."'>Disable</a>";
                        $app_status .= PIPE;
                        $app_status .= "<a href='". site_url('apps/manager/execute/uninstall/' . $objModule->get_app_name()) ."'>Uninstall</a>";
                    break;

                    case "N":
                        $app_status = "Install";
                        $app_status .= PIPE;
                        $app_status .= "<a href='". site_url('apps/manager/execute/activate/' . $objModule->get_app_name()) ."'>Activate</a>";
                        $app_status .= PIPE;
                        $app_status .= "Upgrade";
                        $app_status .= PIPE;
                        $app_status .= "Uninstall";
                        $app_status .= PIPE;
                        $app_status .= "Remove";
                    break;

                    default:
                        $app_status = "<a href='". site_url('apps/manager/execute/install/' . $objModule->get_app_name()) ."'>Install</a>";
                        $app_status .= PIPE;
                        $app_status .= "Activate";
                        $app_status .= PIPE;
                        $app_status .= "Upgrade";
                        $app_status .= PIPE;
                        $app_status .= "Uninstall";
                        $app_status .= PIPE;
                        $app_status .= "Remove";
                    break;
                }

                $result_set[] = array(
                    'app'    => $objModule->get_app_name(),
                    'title'    => $objModule->get_app_title(),
                    'description'    => $app_description,
                    'version'   => number_format($current_ver, 2),
                    'status'   => $app_status
                );
                //echo "<br>[inside loop for:" . $module_info_class . "]";
                //$result_set[] = $module_info;
                unset($objModule);
                unset($app_status);
            }
        }

        //<editor-fold desc="LOAD THE TEMPLATE">
        $this->template->set('sb_sticky', '<b>SOME FUN FACTS...</b><br><br>
                                1. Clicking INSTALL will install the app.<br><br>
                                2. Clicking ACTIVATE will enable the app, if it was disabled.<br><br>
                                3. Clicking UPGRADE will upgrade the app to the latest version.<br><br>
                                4. Clicking DISABLE will disable the app (not remove it but just hide it from the main menu).<br><br>
                                5. Clicking UNINSTALL will remove the app completely and delete all the data and associated tables, so be careful.<br><br>
                                <b>Browse more apps in SMP Marketplace. <a href=http://www.sitemanpro.com/extras/ target=_New>Click here!</a>');

        $this->template->set('resultset', $result_set);
        $this->template->set('pagination', '');
        $this->template->view($this->config->item('app_list_view'));
        //</editor-fold>
    }

    /**
     * Function: execute
     * Description: Execute the action on app
     * ##############################################################
     * Written: 04/01/2011
     * Author: Deep Arora
     * --------------------------------------------------------------
     * Update Log:
     * --------------------------------------------------------------
     * ##############################################################
     * @access public
     * @return void
     */
    function execute($action = '', $app = '')
    {
        $module_info_class = APPPATH . "modules/" . $app . "/module_" . $app . ".php";
        $module_class_name = "Module_" . $app;

        if(file_exists($module_info_class)){
            include $module_info_class;
            $objModule = new $module_class_name();
            switch($action) {
                case "disable":
                    $objModule->disable();
                break;

                case "uninstall":
                    $objModule->uninstall();
                break;

                case "upgrade":
                    $objModule->upgrade();
                break;

                case "activate":
                    $objModule->activate();
                break;

                case "install":
                    $objModule->install();
                break;
            }
            unset($objModule);
        }
        //$this->session->set_flashdata('system_message', $system_message);
        redirect('apps/manager/', 'location');
    }

}

/* End of file manager.php */
/* Location: ./app/modules/apps/controllers/manager.php */