<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Offline extends Controller {

    function __construct() {
            parent::Controller();
    }

    function process($product_id = '')
    {
        if (!smp_check_session()){
            $product_id = smp_encode($product_id);
            $getP = site_url('socket/shop/getP/' . $product_id);
            header('Location: ' . $getP);
        }
        else {
            $product_type = smp_lookup('product_type', $this->config->item('tbl_products'), 'product_id = ' . $product_id);
            $product_price = smp_lookup('price', $this->config->item('tbl_products'), 'product_id = ' . $product_id);
            $this->_process($product_id);

        }
    }


    function _process($productId)
    {
            $productIdInDB = smp_lookUp("product_id", $this->config->item('tbl_products'), "product_id = " . $productId);
            $user_id = $this->session->userdata('user_id');
            $user_name = smp_lookUp("username", $this->config->item('tbl_users'), "user_id = " . $user_id);
            $user_password = smp_lookUp("password", $this->config->item('tbl_users'), "user_id = " . $user_id);
            $user_email = smp_lookup("email", $this->config->item('tbl_users'), "user_id = " . $user_id);
            $user_first_name = smp_lookup("first_name", $this->config->item('tbl_users'), "user_id = " . $user_id);
            $user_last_name = smp_lookup("last_name", $this->config->item('tbl_users'), "user_id = " . $user_id);


            $channel = smp_lookup('title', $this->config->item('tbl_gateways'), 'setting_1 = \'Offline\'');
            if (!$channel){
                $channel = "Offline";
            }


            if ($productId == $productIdInDB) {
                $productName = smp_lookup("product_name", $this->config->item('tbl_products'), "product_id = " . $productId);
                $currency_code = smp_lookup("currency_code", $this->config->item('tbl_products'), "product_id = " . $productId);
                $add_grp = smp_lookup("add_grp", $this->config->item('tbl_products'), "product_id = " . $productId);
                $remove_grp = smp_lookup("remove_grp", $this->config->item('tbl_products'), "product_id = " . $productId);
                $productReturnURL = smp_lookup("return_url", $this->config->item('tbl_products'), "product_id = "  . $productId);
                $productDuration = smp_lookup("expire_download", $this->config->item('tbl_products'), "product_id = " . $productId);
                $autoresponder_unit = smp_lookup("autoresponder_unit", $this->config->item('tbl_products'), "product_id = " . $productId);
                $shop_notify_success = smp_lookup("key_value", $this->config->item('tbl_config'), "key_name = 'NOTIFY_SUCCESS'");
                $shop_notify_void = smp_lookup("key_value", $this->config->item('tbl_config'), "key_name = 'NOTIFY_VOID'");
                $tpl_email_sale_completed = smp_lookup("key_value", $this->config->item('tbl_config'), "key_name = 'TPL_EMAIL_NEW_ORDER_USER'");
                $tpl_email_sale_default = smp_lookup("key_value", $this->config->item('tbl_config'), "key_name = 'TPL_EMAIL_NEW_ORDER_USER'");
                $admin_email = smp_lookup("key_value", $this->config->item('tbl_config'), "key_name = 'ADMIN_EMAIL'");
                $admin_name = smp_lookup("key_value", $this->config->item('tbl_config'), "key_name = 'ADMIN_NAME'");

                $productQuantity = 1;
                $productBasicPrice = smp_lookup("price", $this->config->item('tbl_products'), "product_id = " . $productId);
            }
            else {
                smp_log("[offline.php]Product ID Received [" . $productId . "] Doesnt Match With Product ID in DB [" . $productIdInDB . "]");
                exit;
            }

            $productGross = smp_lookup("price", $this->config->item('tbl_products'), "product_id = " . $productId);

            $txn_id = strtoupper(smp_getrandstring(17));

            /* SET THE TRANSACTION CODE BASED ON THE PAYMENT STATUS RECEIVED */
            $payment_status = strtolower('pending');
            $trans_status_code = 1;
            $transStatusChange = "";
            $transUpdateUser = false;
            $flag_transaction_status = "";

            $flag_transaction_status = "NEW";
            if ($flag_transaction_status == "NEW"){
                // CREATE NEW TRANSACTION RECORD
                if ($productDuration == 0){
                    $productDuration = 999;
                }
                $expire_date = smp_add_days_to_date(smp_datetime(),$productDuration);
                $field_array_transaction['transaction_date'] = smp_datetime();
                $field_array_transaction['begin_date'] = smp_datetime();
                $field_array_transaction['expire_date'] = $expire_date;
                $field_array_transaction['transaction_memo'] = $user_id;
                $field_array_transaction['currency_code'] = $currency_code;
                $field_array_transaction['transaction_amount'] = $productGross;
                $field_array_transaction['user_id'] = $user_id;
                $field_array_transaction['gateway_id'] = $txn_id;
                $field_array_transaction['transaction_status_details'] = $payment_status;
                $field_array_transaction['transaction_type'] = 1;
                $field_array_transaction['transaction_category'] = 1;
                $field_array_transaction['transaction_title'] = $productName;
                $field_array_transaction['transaction_status_code'] = $trans_status_code;
                $field_array_transaction['channel'] = $channel;
                $this->db->insert($this->config->item('tbl_transactions'), $field_array_transaction);

                //smp_log("PAYPAL TRANSACTION ID: " . $txn_id);
                $orderId = $this->db->insert_id();
                //smp_log("LATEST TRANSACTION ID: " . $orderId);

                //smp_log("Inserting in Shop Order Items");
                $field_array_orderitems['quantity'] = $productQuantity;
                $field_array_orderitems['price'] = $productGross;
                $field_array_orderitems['order_id'] = $orderId;
                $field_array_orderitems['product_id'] = $productId;
                $this->db->insert($this->config->item('tbl_order_items'), $field_array_orderitems);
                //smp_log("Inserted in Shop Order Items");


                /* UPDATING USER GROUP IF SET IN PRODUCT CONFIGURATION */
                if ($add_grp > 0){
                    if ($remove_grp) {
                        $remove_grp = $remove_grp;
                    }
                    else {
                        $changeback_grp = 0;
                    }
                    if ($trans_status_code == 1){
                        $field_array_users['role_id'] = $add_grp;
                    }
                    if ($trans_status_code == 0 && $remove_grp > 0){
                        $field_array_users['role_id'] = $remove_grp;
                    }
                    $where = "user_id = " . $user_id;
                    $this->db->update($this->config->item('tbl_users'), $field_array_users);
                    //smp_log("UPDATED USER GROUP");
                }



                /* ADDING CUSTOMER TO AUTORESPONDER, IF SPECIFIED */
                if ($autoresponder_unit <> ""){
                    //smp_log("ADDING CUSTOMER TO AR");
                    // load email lib and email results
                    $data['subject'] = '[SUBSCRIBE]';
                    $data['message'] = '[SUBSCRIBE]';
                    $data['from'] = $user_email;
                    $data['name'] = $user_first_name;
                    $data['to'] = $autoresponder_unit;
                    smp_sendmail($data);
                    smp_log("[offline.php]CUSTOMER ADDED TO AR");
                    //smp_log("CUSTOMER ADDED TO AR");
                }

                /* FINALLY, NOTIFY CUSTOMER & ADMIN BY EMAIL --- STARTS */
                $emailTpl = "";
                $emailTpl = smp_lookup("key_value", $this->config->item('tbl_config'), "key_name = 'TPL_EMAIL_NEW_ORDER_USER'");
                //smp_log("NOTIFYING CUSTOMER");

                if ($emailTpl<>"")
                {
                    $download_link = $productReturnURL;
                    $emailTpl = str_replace("{first_name}", $user_first_name, $emailTpl);
                    $emailTpl = str_replace("{last_name}", $user_last_name, $emailTpl);
                    $emailTpl = str_replace("{download_link}", $download_link, $emailTpl);
                    $emailTpl = str_replace("{admin_name}", $admin_name, $emailTpl);
                    $emailTpl = str_replace("{item_name}", $productName, $emailTpl);
                    $emailTpl = str_replace("{username}", $user_name, $emailTpl);
                    $emailTpl = str_replace("{password}", $user_password, $emailTpl);

                    $data['subject'] = '[Your Order]:' . $productName;
                    $data['message'] = $emailTpl;
                    $data['from'] = $admin_email;
                    $data['name'] = $admin_name;
                    $data['to'] = $user_email;
                    $data['bcc'] = $admin_email;
                    smp_sendmail($data);
                    //smp_log("CUSTOMER NOTIFIED BY EMAIL");
                }
                /* FINALLY, NOTIFY CUSTOMER & ADMIN BY EMAIL --- ENDS */

            }

            if ($productReturnURL){
                header('Location: ' . $productReturnURL);
            }
            else {
                echo "This product is added to your purchases. Please access customer area to access the product.";
            }




    }

}

/* End of file offline.php */
/* Location: ./app/controllers/gateways/offline.php */