<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

/**
 * Clickbank_Lib Controller Class (Paypal IPN Class)
 *
 */

class Clickbank_Lib {

    var $last_error;			// holds the last error encountered
    var $ipn_log;			// bool: log IPN results to text file?

    var $ipn_log_file;			// filename of the IPN log
    var $ipn_response;			// holds the IPN response from paypal
    var $ipn_data = array();            // array contains the POST values for IPN
    var $fields = array();		// array holds the fields to submit to paypal

    var $submit_btn = '';		// Image/Form button
    var $button_path = '';		// The path of the buttons

    var $CI;

    function Clickbank_Lib()
    {
        $this->CI =& get_instance();
        $this->CI->load->helper('url');
        $this->CI->load->helper('form');

        $this->last_error = '';
        $this->ipn_response = '';
        //$this->button('Pay Now!');
    }

    function validate_ipn(){
        $ipnFields = array();
        foreach ($_POST as $key => $value) {
            if ($key == "cverify") {
                continue;
            }
            $ipnFields[] = $key;
        }

        sort($ipnFields);
        foreach ($ipnFields as $field) {
            // if Magic Quotes are enabled $_POST[$field] will need to be
            // un-escaped before being appended to $pop
            $pop = $pop . $_POST[$field] . "|";
        }

        foreach($_POST as $paramKey => $paramValue) {
            $var_name = $paramKey;
            $this->ipn_data[$var_name] = smp_getfrompost($paramKey);
            smp_log("IPNData:" . $var_name . ":" . $this->ipn_data[$var_name]);
        }

        $cvendthru = $_REQUEST["cvendthru"];
        smp_log("cvendthru:" . $_REQUEST["cvendthru"]);
        parse_str($cvendthru, $cdata);
        smp_log("user_id:" . $cdata["smpuid"]);
        smp_log("gateway_id:" . $cdata["smpgid"]);
        smp_log("product_id:" . $cdata["smppid"]);
        smp_log("cverify:" . $_POST["cverify"]);

        $this->ipn_data['user_id'] = $cdata["smpuid"];
        $this->ipn_data['product_id'] = $cdata["smppid"];
        $this->ipn_data['gateway_id'] = $cdata["smpgid"];

        $where_condition = 'gateway_id = ' . $this->ipn_data['gateway_id'];
        $secretKey = smp_lookup('setting_2', $this->CI->config->item('tbl_gateways'), $where_condition);
        smp_log("Key:" . $secretKey);

        $pop = $pop . $secretKey;


        smp_log("pop:" . $pop);
        $calcedVerify = sha1(mb_convert_encoding($pop, "UTF-8"));
        smp_log("calcedverify:" . $calcedVerify);
        $calcedVerify = strtoupper(substr($calcedVerify,0,8));
        smp_log("calcedverify:" . $calcedVerify);
        return $calcedVerify == $_POST["cverify"];

    }
    function validate_ipn1()
    {
        $ccustname = $_POST['ccustname'];
        $ccustemail = $_POST['ccustemail'];
        $ccustcc = $_POST['ccustcc'];
        $ccuststate = $_POST['ccuststate'];
        $ctransreceipt = $_POST['ctransreceipt'];
        $cproditem = $_POST['cproditem'];
        $ctransaction = $_POST['ctransaction'];
        $ctransaffiliate = $_POST['ctransaffiliate'];
        $ctranspublisher = $_POST['ctranspublisher'];
        $cprodtype = $_POST['cprodtype'];
        $cprodtitle = $_POST['cprodtitle'];
        $ctranspaymentmethod = $_POST['ctranspaymentmethod'];
        $ctransamount = $_POST['ctransamount'];
        $caffitid = $_POST['caffitid'];
        $cvendthru = $_POST['cvendthru'];
        $cbpop = $_POST['cverify'];

        // Shippable Media parameters
        $ccustaddr1 = $_POST['ccustaddr1'];
        $ccustaddr2 = $_POST['ccustaddrd'];
        $ccustcity = $_POST['ccustcity'];
        $ccustcounty = $_POST['ccustcounty'];
        $ccustzip = $_POST['ccustzip'];

        // Extract custom variabled first
        smp_log("cvendthru" . $cvendthru);
        $custom_variables = explode("&", $cvendthru);
        smp_log("Custom CB Variable:" . $custom_variables);
        $user_id = explode("=", $custom_variables[0]);
        $product_id = explode("=", $custom_variables[1]);
        $gateway_id = explode("=", $custom_variables[2]);

        $user_id = $user_id[1];
        $product_id = $product_id[1];
        $gateway_id = $gateway_id[1];
        $where_condition = 'gateway_id = ' . $gateway_id;
        $key = smp_lookup('setting_2', $this->CI->config->item('tbl_gateways'), $where_condition);
        smp_log("Key:" . $key);

        $xxpop = "";
        if (strpos($cprodtype, "PHYSICAL") === false) {
            $xxpop = sha1("$ccustname|$ccustemail|$ccustcc|$ccuststate|$ctransreceipt|$cproditem|$ctransaction|"
                          ."$ctransaffiliate|$ctranspublisher|$cprodtype|$cprodtitle|$ctranspaymentmethod|$ctransamount|$caffitid|$cvendthru|$key");
        } else {
            $xxpop = sha1("$ccustname|$ccustemail|$ccustcc|$ccuststate|$ctransreceipt|$cproditem|$ctransaction|"
                          ."$ctransaffiliate|$ctranspublisher|$cprodtype|$cprodtitle|$ctranspaymentmethod|$ctransamount|$caffitid|$cvendthru|"
                          ."$ccustaddr1|$ccustaddr2|$ccustcity|$ccustcounty|$ccustzip|$key");
        }

        $xxpop=strtoupper(substr($xxpop,0,8));
        smp_log("xxpop:" . $xxpop);

        if ($cbpop==$xxpop) return 1;
        else return 0;
    }

    function log_ipn_results($success)
    {
        if (!$this->ipn_log) return;  // is logging turned off?

        // Timestamp
        $text = '['.date('m/d/Y g:i A').'] - ';

        // Success or failure being logged?
        if ($success) $text .= "SUCCESS!\n";
        else $text .= 'FAIL: '.$this->last_error."\n";

        // Log the POST variables
        $text .= "IPN POST Vars from Paypal:\n";
        foreach ($this->ipn_data as $key=>$value)
                $text .= "$key=$value, ";

        // Log the response from the paypal server
        $text .= "\nIPN Response from Paypal Server:\n ".$this->ipn_response;

        // Write to log
        $fp=fopen($this->ipn_log_file,'a');
        fwrite($fp, $text . "\n\n");

        fclose($fp);  // close file
    }


    function dump()
    {
        // Used for debugging, this function will output all the field/value pairs
        // that are currently defined in the instance of the class using the
        // add_field() function.

        ksort($this->fields);
        echo '<h2>ppal->dump() Output:</h2>' . "\n";
        echo '<code style="font: 12px Monaco, \'Courier New\', Verdana, Sans-serif;  background: #f9f9f9; border: 1px solid #D0D0D0; color: #002166; display: block; margin: 14px 0; padding: 12px 10px;">' . "\n";
        foreach ($this->fields as $key => $value) echo '<strong>'. $key .'</strong>:	'. urldecode($value) .'<br/>';
        echo "</code>\n";
    }

}

?>